---
author: marc
title: Gitlab
date: 9 novembre 2019
---


# Les remotes

---

## Git est distribué

![](images/gitlab/distributed_git.png){ width=40% }

::: notes
On dit que git est distribué
Cela veut dire que n'importe quel ordinateur va généralement héberger l'entièreté du repos
et de la liste des versions

cela veut aussi dire que l'on peut se connecter à n'importe quel autre ordinateur contenant
ce repos pour se mettre à jour

on va avoir un serveur mais il est "un ordinateur parmis d'autres"
:::

---

## Paramétrage

- aller sur [https://gitlab.clubelek.fr](https://gitlab.clubelek.fr)
- se connecter avec son compte clubelek
- enregistrer un mot de passe

---

## Gestion des remotes

```bash
# initialisation
mkdir example-remote
cd example-remote
git init

# lister les remote
git remote -v

# ajouter un remote (en une seule ligne)
git remote add origin https://gitlab.clubelek.fr/formations
/software-engineering/example-remote.git

git remote -v
```

---

## Synchronisation

```bash
# télécharger les modifications
git pull

# uploader des modifications
git push <nom remote> <nom branche>
```

---

## Forges logicielles

![](images/gitlab/logos_forge.png){ width=30% }

- hébergement de répertoires
- fonctionnalités de gestion de projet

::: notes
Les forges logicielles permettent de gérer des répertoires versionnés, mais ont en plus des outils supplémentaires de gestion de projet
:::


# Fonctionnalités

---

## Issues

Pour faire des propositions théoriques

- améliorations
- questions
- bugs

Permet de lister les tâches pour les dévellopeurs

---

![](images/gitlab/issues.png)

::: notes
Les issues vont être utile pour tracker l'avancement d'un projet et les tâches
:::

---

[https://gitlab.clubelek.fr/formations/software-engineering/example-remote/issues](https://gitlab.clubelek.fr/formations/software-engineering/example-remote/issues)

**Pratique** : ajouter une issue

---

## Merge requests (MR)

Pour proposer des modificatinos de code

En pratique, on va toujours utiliser des merge requests quand on modifie le code !

---

![](images/gitlab/mr.png)

---

**Pratique** :

1. créer une nouvelle branche `votre_nom/rabbit`
2. créer un nouveau commit
3. `git push <nom remote> <nom branche>`

Qu'est-ce qui s'affiche ?

. . .

Un lien pour créer la MR créé par gitlab.

Il est également possible d'en créer depuis l'interface

---

## Discussion

Pour les issues et les merge requests, une interface de discussion est disponible

- pertinence ou manière d'implémenter une issue
- review de code

## Labels

Catégorisation des issues et des Merge requests

---

Type :

![](images/gitlab/label_type.png)

---

Statut :

![](images/gitlab/label_status.png)

---

Priorité : 

![](images/gitlab/label_priority.png)

---

**Exemple**

[https://gitlab.clubelek.fr/formations/software-engineering/example-remote/issues](https://gitlab.clubelek.fr/formations/software-engineering/example-remote/issues)

---

## Milestones

Permet de définir des échances

- versions
- réunions/présentations

![](images/gitlab/milestones.png)

---

## Workflow: dévellopeur

1. Implémentation en local sur une branche à part
2. `git push <remote> <nom_branche>`
3. Création d'une merge request

---

## Workflow: mainteneur

0. Regarder régulièrement les repos qu'il maintient
1. Assigner des labels aux issues et aux merge request
2. Définir quelles issues vont faire partie des milestones
3. Faire une revue du code proposé dans chaque merge request
4. Fusionner le code s'il le trouve convenable
5. Fermer les issues associées



# TL;DR

---

```bash
git remote add <nom> <url> #ajouter un remote
git remote -v   #lister les remote
git push        # mettre en ligne des modifications
git pull        # mettre à jour le dossier local
```

- **issues** : propositions
- **merge requests** : implémentations
- **milestones** : échéances
- **labels** : catégorisation des issues/MR

---

Une ressource utile :
[https://git-scm.com/book](https://git-scm.com/book)
